; multsoft.inc
; 20.05.2021
;
;=================================================================================
;=== mul unsigned ================================================================
;=================================================================================
;
; multsoft_8x8_16		@0,1 result (@1 MSB),@2 mult1,@3 mult2,@4 Hilfsreg
; 				mult1 0...255, mult2 0...255, result 0...65025
; 				6-86 cycles 24 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x16_24	@0-2 result (@2 MSB), @3 mult1
; 				@4,5 mult2 (@5 MSB), @6 Hilfsreg
; 				mult1 0...255, mult2 0...65535, result 0...16711425
; 				7-103 cycles 30 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x24_32	@0-3 result (@3 MSB), @4 mult1
; 				@5-7 mult2 (@7 MSB), @8 Hilfsreg
; 				mult1 0...255, mult2 0...16777215, result 0...4278189825
; 				8-120 cycles 36 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x32_40	@0-4 result (@4 MSB), @5 mult1
; 				@6-9 mult2 (@9 MSB), @10 Hilfsreg
; 				mult1 0...255, mult2 0...4294967295, result 0...1095216660225
; 				9-137 cycles 42 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x40_48	@0-5 result (@5 MSB), @6 mult1
; 				@7-11 mult2 (@11 MSB), @12 Hilfsreg
; 				mult1 0...255, mult2 0...1099511627775
; 				result 0...280375465082625
; 				10-154 cycles 48 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x48_56	@0-6 result (@6 MSB), @7 mult1
; 				@8-13 mult2 (@13 MSB), @14 Hilfsreg
; 				mult1 0...255, mult2 0...281474976710655
; 				result 0...71776119061217025
; 				11-171 cycles 54 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_8x56_64	@0-7 result (@7 MSB), @8 mult1
; 				@9-15 mult2 (@15 MSB), @16 Hilfsreg
; 				mult1 0...255, mult2 0...72057594037927935
; 				result 0...18374686479671623425
; 				12-188 cycles 60 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=255
;
; multsoft_16x16_32	@0-3 result (@3 MSB), @4,5 mult1 (@5 MSB)
; 				@6,7 mult2 (@7 MSB), @8,9 Hilfsreg
; 				mult1 0...65535, mult2 0...65535 
; 				result 0...4294836225
; 				11-267 cycles 44 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=65535
;
; multsoft_16x24_40	@0-4 result (@4 MSB), @5,6 mult1 (@6 MSB)
; 				@7-9 mult2 (@9 MSB), @10,11 Hilfsreg
; 				mult1 0...65535, mult2 0...16777215 
; 				result 0...1099494785025
; 				12-300 cycles 50 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=65535
;
; multsoft_16x32_48	@0-5 result (@5 MSB), @6,7 mult1 (@7 MSB)
; 				@8-11 mult2 (@11 MSB), @12,13 Hilfsreg
; 				mult1 0...65535, mult2 0...4294967295
; 				result 0...281470681677825
; 				13-333 cycles 56 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=65535
;
; multsoft_16x40_56	@0-6 result (@6 MSB), @7,8 mult1 (@8 MSB)
; 				@9-13 mult2 (@13 MSB), @14,15 Hilfsreg
; 				mult1 0...65535, mult2 0...1099511627775
; 				result 0...72056494526234625
; 				14-366 cycles 62 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=65535
;
; multsoft_16x48_64	@0-7 result (@7 MSB), @8,9 mult1 (@9 MSB)
; 				@10-15 mult2 (@13 MSB), @16,17 Hilfsreg
; 				mult1 0...65535, mult2 0...281474976710655
; 				result 0...18446462598732775425
; 				15-399 cycles 68 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=65535
;
; multsoft_24x24_48	@0-5 result (@5 MSB), @6-8 mult1 (@8 MSB)
; 				@9-11 mult2 (@9 MSB), @12-14 Hilfsreg
; 				mult1 0...16777215, mult2 0...16777215 
; 				result 0...281474943156225
; 				16-520 cycles 64 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=16777215
;
; multsoft_24x32_56	@0-6 result (@6 MSB), @7-9 mult1 (@9 MSB)
; 				@10-13 mult2 (@13 MSB), @14-16 Hilfsreg
; 				mult1 0...16777215, mult2 0...4294967295
; 				result 0...72057589726183425
; 				17-569 cycles 70 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=16777215
;
; multsoft_24x40_64	@0-7 result (@7 MSB), @8-10 mult1 (@10 MSB)
; 				@11-15 mult2 (@15 MSB), @16-18 Hilfsreg
; 				mult1 0...16777215, mult2 0...1099511627775
; 				result 0...18446742974181146625
; 				18-618 cycles 76 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=16777215
;
; multsoft_32x32_64	@0-7 result (@7 MSB), @8-11 mult1 (@11 MSB)
; 				@12-15 mult2 (@15 MSB), @16-19 Hilfsreg
; 				mult1 0...4294967295, mult2 0...4294967295 
; 				result 0...18446744065119617025
; 				21-853 cycles 84 bytes
; 				min.cycles wenn mult1=0, max.cycles wenn mult1=4294967295
;
;
;=================================================================================
;=== mul signed ==================================================================
;=================================================================================
;
; multsoft_8x8_16_s		@0,1 result (@1 MSB), @2 mult1
; 				@3 mult2, @4 Hilfsreg
; 				mult1 -128...127, mult2 -128...127, result -16256...16384
; 				15-94 cycles, 62 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=-128 und mult2>0
;
; multsoft_8x16_24_s	@0-2 result (@2 MSB), @3 mult1
; 				@4,5 mult2 (@5 MSB), @6 Hilfsreg
; 				mult1 -128...127, mult2 -32768...32767
; 				result -4194176...4194304
; 				16-115 cycles, 82 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=127 und mult2<0
;
; multsoft_8x24_32_s	@0-3 result (@3 MSB), @4 mult1
; 				@5-7 mult2 (@7 MSB), @8 Hilfsreg
; 				mult1 -128...127, mult2 -8388608...8388607
; 				result -1073741696...1073741824
; 				17-134 cycles, 96 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=127 und mult2<0
;
; multsoft_8x32_40_s	@0-4 result (@4 MSB), @5 mult1
; 				@6-9 mult2 (@9 MSB), @10 Hilfsreg
; 				mult1 -128...127, mult2 -2147483648...2147483647
; 				result -274877906816...274877906944
; 				18-153 cycles, 110 bytes
; 				min.cycles wenn mult1=0 und mult2>0
;		 		max.cycles wenn mult1=127 und mult2<0 
;
; multsoft_8x40_48_s	@0-5 result (@5 MSB), @6 mult1
; 				@7-11 mult2 (@11 MSB), @12 Hilfsreg
; 				mult1 -128...127, mult2 -549755813888...549755813887
; 				result -70368744177536...70368744177664
; 				19-172 cycles, 124 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=127 und mult2<0 
;
; multsoft_8x48_56_s	@0-6 result (@6 MSB), @7 mult1
; 				@8-13 mult2 (@13 MSB), @14 Hilfsreg
; 				mult1 -128...127, mult2 -140737488355328...140737488355327
; 				result -18014398509481856...18014398509481984
; 				20-191 cycles, 138 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=127 und mult2<0 
;
; multsoft_8x56_64_s	@0-7 result (@7 MSB), @8 mult1
; 				@9-15 mult2 (@15 MSB), @16 Hilfsreg
; 				mult1 -128...127, mult2 -36028797018963968...36028797018963967
; 				result -4611686018427387776...4611686018427387904
; 				21-210 cycles, 152 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=127 und mult2<0 
;
; multsoft_16x16_32_s	@0-3 result (@3 MSB), @4,5 mult1 (@5 MSB)
; 				@6,7 mult2 (@7 MSB), @8,9 Hilfsreg
; 				mult1 -32768...32767, mult2 -32768...32767 
; 				result -1073709056...1073741824
; 				20-277 cycles, 110 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=32767 und mult2<0 
;
; multsoft_16x24_40_s	@0-4 result (@4 MSB), @5,6 mult1 (@6 MSB)
; 				@7-9 mult2 (@9 MSB), @10,11 Hilfsreg
; 				mult1 -32768...32767, mult2 -8388608...8388607
; 				result -274877874176...274877906944
; 				21-312 cycles, 124 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=32767 und mult2<0 
;
; multsoft_16x32_48_s	@0-5 result (@5 MSB), @6,7 mult1 (@7 MSB)
; 				@8-11 mult2 (@11 MSB), @12,13 Hilfsreg
; 				mult1 -32768...32767, mult2 -2147483648...2147483647
; 				result -70368744144896...70368744177664
; 				22-347 cycles, 138 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=32767 und mult2<0 
;
; multsoft_16x40_56_s	@0-6 result (@6 MSB), @7,8 mult1 (@8 MSB)
; 				@9-13 mult2 (@13 MSB), @14,15 Hilfsreg
; 				mult1 -32768...32767, mult2 -549755813888...549755813887
; 				result -18014398509449216...18014398509481984
; 				23-382 cycles, 152 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=32767 und mult2<0 
;
; multsoft_16x48_64_s	@0-7 result (@7 MSB), @8,9 mult1 (@9 MSB)
; 				@10-15 mult2 (@13 MSB), @16,17 Hilfsreg
; 				mult1 -32768...32767, mult2 -140737488355328...140737488355327
; 				result -4611686018427355136...4611686018427387904
; 				24-417 cycles, 166 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=32767 und mult2<0 
;
; multsoft_24x24_48_s	@0-5 result (@5 MSB), @6-8 mult1 (@8 MSB)
; 				@9-11 mult2 (@9 MSB), @12-14 Hilfsreg
; 				mult1 -8388608...8388607, mult2 -8388608...8388607
; 				result -70368735789056...70368744177664
; 				25-531 cycles, 146 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=8388607 und mult2<0 
;
; multsoft_24x32_56_s	@0-6 result (@6 MSB), @7-9 mult1 (@9 MSB)
; 				@10-13 mult2 (@13 MSB), @14-16 Hilfsreg
; 				mult1 -8388608...8388607, mult2 -2147483648...2147483647
; 				result -18014398501093376...18014398509481984
; 				26-582 cycles, 160 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=8388607 und mult2<0 
;
; multsoft_24x40_64_s	@0-7 result (@7 MSB), @8-10 mult1 (@10 MSB)
; 				@11-15 mult2 (@15 MSB), @16-18 Hilfsreg
; 				mult1 -8388608...8388607, mult2 -549755813888...549755813887
; 				result -4611686018418999296...4611686018427387904
; 				27-633 cycles, 174 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=8388607 und mult2<0
;
; multsoft_32x32_64_s	@0-7 result (@7 MSB), @8-11 mult1 (@11 MSB)
; 				@12-15 mult2 (@15 MSB), @16-19 Hilfsreg
; 				mult1 -2147483648...2147483647
; 				mult2 -2147483648...2147483647
; 				result -4611686016279904256...4611686018427387904
; 				30-865 cycles, 182 bytes
; 				min.cycles wenn mult1=0 und mult2>0
; 				max.cycles wenn mult1=2147483647 und mult2<0
;
;
;=================================================================================
;=== mul signed/unsigned =========================================================
;=================================================================================
; 
; multsoft_8x8_16_su	@0,1 result (@1 MSB), @2 mult_s, @3 mult_u, @4 Hilfsreg
; 				mult_s -128...127, mult_u 0...255, result -32640...32385
; 				12-91 cycles, 48 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-128
; 
; multsoft_8x16_24_su	@0-2 result (@2 MSB), @3 mult_s
; 				@4,5 mult_u (@5 MSB), @6 Hilfsreg
; 				mult_s -128...127, mult_u 0...65535, result -8388480...8322945
; 				13-105 cycles, 58 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-127
; 
; multsoft_8x24_32_su	@0-3 result (@3 MSB), @4 mult_s
; 				@5-7 mult_u (@7 MSB), @8 Hilfsreg
; 				mult_s -128...127, mult_u 0...16777215
; 				result -2147483520...2130706305
; 				14-122 cycles, 68 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-127
; 
; multsoft_8x32_40_su	@0-4 result (@4 MSB), @5 mult_s
; 				@6-9 mult_u (@9 MSB), @10 Hilfsreg
; 				mult_s -128...127, mult_u 0...4294967295
; 				result -549755813760...545460846465
; 				15-139 cycles, 78 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-127
; 
; multsoft_8x40_48_su	@0-5 result (@5 MSB), @6 mult_s
; 				@7-11 mult_u (@11 MSB), @12 Hilfsreg
; 				mult_s -128...127, mult_u 0...1099511627775
; 				result -140737488355200...139637976727425
; 				16-142 cycles, 88 bytes
; 				min.cycles wenn mult_s=0
; 
; multsoft_8x48_56_su	@0-6 result (@6 MSB), @7 mult_s
; 				@8-13 mult_u (@13 MSB), @14 Hilfsreg
; 				mult_s -128...127, mult_u 0...281474976710655
; 				result -36028797018963840...35747322042253185
; 				17-173 cycles, 98 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-127
; 
; multsoft_8x56_64_su	@0-7 result (@7 MSB), @8 mult_s
; 				@9-15 mult_u (@15 MSB), @16 Hilfsreg
; 				mult_s -128...127, mult_u 0...72057594037927935
; 				result -9223372036854775680...9151314442816847745
; 				18-190 cycles, 108 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-127
; 
; multsoft_16x8_24_su	@0-2 result (@2 MSB), @3,@4 mult_s (@4 MSB)
; 				@5 mult_u, @6 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...255, result -8355840...8355585
; 				13-122 cycles, 68 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=255 und mult_s<0
;
; multsoft_16x16_32_su	@0-3 result (@3 MSB), @4,5 mult_s (@5 MSB)
; 				@6,7 mult_u (@7 MSB), @8,9 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...65535, 
;				result -2147450880...2147385345
; 				17-272 cycles, 86 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-32767
; 
; multsoft_16x24_40_su	@0-4 result (@4 MSB), @5,6 mult_s (@6 MSB)
; 				@7-9 mult_u (@9 MSB), @10,11 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...16777215
; 				result -549755781120...549739003905
; 				18-305 cycles, 96 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-32767
; 
; multsoft_16x32_48_su	@0-5 result (@5 MSB), @6,7 mult_s (@7 MSB)
; 				@8-11 mult_u (@11 MSB), @12,13 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...4294967295
; 				result -140737488322560...140733193355265
; 				19-338 cycles, 106 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-32767
; 
; multsoft_16x40_56_su	@0-6 result (@6 MSB), @7,8 mult_s (@8 MSB)
; 				@9-13 mult_u (@13 MSB), @14,15 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...1099511627775
; 				result -36028797018931200...36027697507303425
; 				20-371 cycles, 116 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-32767
; 
; multsoft_16x48_64_su	@0-7 result (@7 MSB), @8,9 mult_s (@9 MSB)
; 				@10-15 mult_u (@15 MSB), @16,17 Hilfsreg
; 				mult_s -32768...32767, mult_u 0...281474976710655
; 				result -9223372036854743040...9223090561878032385
; 				21-404 cycles, 126 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-32767
; 
; multsoft_24x8_32_su	@0-3 result (@3 MSB), @4-6 mult_s (@6 MSB)
; 				@7 mult_u, @8 Hilfsreg
; 				mult_s -8388608...8388607, mult_u 0...255
; 				result -2139095040...2139094785
; 				14-143 cycles, 126 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=256 und mult_s<0
; 
; multsoft_24x16_40_su	@0-4 result (@4 MSB), @5-7 mult_s (@7 MSB)
; 				@8,9 mult_u (@9 MSB), @10,11 Hilfsreg
; 				mult_s -8388608...8388607, mult_u 0...65535
; 				result -549747425280...549747359745
; 				18-325 cycles, 100 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=65535 und mult_s<0
; 
; multsoft_24x24_48_su	@0-5 result (@5 MSB), @6-8 mult_s (@8 MSB)
; 				@9-11 mult_u (@11 MSB), @12-14 Hilfsreg
; 				mult_s -8388608...8388607, mult_u 0...16777215
; 				result -140737479966720...140737463189505
; 				22-526 cycles, 118 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-8388607
; 
; multsoft_24x32_56_su	@0-6 result (@6 MSB), @7-9 mult_s (@9 MSB)
; 				@10-13 mult_u (@13 MSB), @14-16 Hilfsreg
; 				mult_s -8388608...8388607, mult_u 0...4294967295
; 				result -36028797010575360...36028792715608065
; 				23-575 cycles, 128 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-8388607
; 
; multsoft_24x40_64_su	@0-7 result (@7 MSB), @8-10 mult_s (@10 MSB)
; 				@11-15 mult_u (@15 MSB), @16-18 Hilfsreg
; 				mult_s -8388608...8388607, mult_u 0...1099511627775
; 				result -9223372036846387200...9223370937334759425
; 				24-624 cycles, 138 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-8388607
; 
; multsoft_32x8_40_su	@0-4 result (@4 MSB), @5-8 mult_s (@8 MSB)
; 				@9 mult_u, @10 Hilfsreg
; 				mult_s -2147483648...2147483647, mult_u 0...255
; 				result -547608330240...547608329985
; 				15-164 cycles, 96 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=255 und mult_s<0
; 
; multsoft_32x16_48_su	@0-5 result (@5 MSB), @6-9 mult_s (@9 MSB)
; 				@10,11 mult_u (@11 MSB), @12,13 Hilfsreg
; 				mult_s -2147483648...2147483647
; 				mult_u 0...65535
; 				result -140735340871680...140735340806145
; 				19-362 cycles, 114 bytes
; 				min.cycles wenn mult_u=0
; 				max.cycles wenn mult_u=65535 und mult_s<0
; 
; multsoft_32x24_56_su	@0-6 result (@6 MSB), @7-10 mult_s (@10 MSB)
; 				@11-13 mult_u (@13 MSB), @14-16 Hilfsreg
; 				mult_s -2147483648...2147483647, mult_u 0...16777215
; 				result -36028794871480320...36028794854703105
; 				23-600 cycles, 132 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=2147483647 und mult_s<0
; 
; multsoft_32x32_64_su	@0-7 result (@7 MSB), @8-11 mult_s (@11 MSB)
; 				@12-15 mult_u (@15 MSB), @16-19 Hilfsreg
; 				mult_s -2147483648...2147483647, mult_u 0...4294967295
; 				result -9223372034707292160...9223372030412324865
; 				27-860 cycles, 150 bytes
; 				min.cycles wenn mult_s=0, max.cycles wenn mult_s=-2147483647
; 
; multsoft_40x8_48_su	@0-5 result (@5 MSB), @6-10 mult_s (@10 MSB)
; 				@11 mult_u, @12 Hilfsreg
; 				mult_s -549755813888...549755813887, mult_u 0...255
; 				result -140187732541440...140187732541185
; 				16-185 cycles, 110 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=255 und mult_s<0
; 
; multsoft_40x16_56_su	@0-6 result (@6 MSB), @7-11 mult_s (@11 MSB)
; 				@12,13 mult_u (@13 MSB), @14,15 Hilfsreg
; 				mult_s -549755813888...549755813887, mult_u 0...65535
; 				result -36028247263150080...36028247263084545
; 				20-399 cycles, 128 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=65535 und mult_s<0
; 
; multsoft_40x24_64_su	@0-7 result (@7 MSB), @8-12 mult_s (@12 MSB)
; 				@13-15 mult_u (@15 MSB), @16-18 Hilfsreg
; 				mult_s -549755813888...549755813887, mult_u 0...16777215
; 				result -9223371487098961920...9223371487082184705
; 				24-653 cycles, 146 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=16777215 und mult_s<0
; 
; multsoft_48x8_56_su	@0-6 result (@6 MSB), @7-12 mult_s (@12 MSB)
; 				@13 mult_u, @14 Hilfsreg
; 				mult_s -140737488355328...140737488355327, mult_u 0...255
; 				result -35888059530608640...35888059530608385
; 				17-206 cycles, 124 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=255 und mult_s<0
; 
; multsoft_48x16_64_su	@0-7 result (@7 MSB), @8-13 mult_s (@13 MSB)
; 				@14.15 mult_u (@15 MSB), @16,17 Hilfsreg
; 				mult_s -140737488355328...140737488355327, mult_u 0...65535
; 				result -9223231299366420480...9223231299366354945
; 				21-436 cycles, 142 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=65535 und mult_s<0
; 
; multsoft_56x8_64_su	@0-7 result (@7 MSB), @8-14 mult_s (@14 MSB)
; 				@15 mult_u, @16 Hilfsreg
; 				mult_s -36028797018963968...36028797018963967, mult_u 0...255
; 				result -9187343239835811840...9187343239835811585
; 				18-227 cycles, 138 bytes
; 				min.cycles wenn mult_u=0, max.cycles wenn mult_u=255 und mult_s<0
; 
;=================================================================================
;=== NEG-Macro ===================================================================
;=================================================================================
;
; neg16		@0,1 Data (@1 MSB), @2 temp, 5c,10b
; neg24		@0-2 Data (@2 MSB), @3 temp, 7c,14b
; neg32		@0-3 Data (@3 MSB), @4 temp, 9c,18b
; neg40		@0-4 Data (@4 MSB), @5 temp, 11c,22b
; neg48		@0-5 Data (@5 MSB), @6 temp, 13c,26b
; neg56		@0-6 Data (@6 MSB), @7 temp, 15c,30b
; neg64		@0-7 Data (@7 MSB), @8 temp, 17c,34b
;
; 
;=================================================================================
 #ifndef _MULTSOFT_
 #define _MULTSOFT_

;=================================================================================
;=== mul unsigned ================================================================
;=================================================================================
.macro multsoft_8x8_16	; @0,1 result (@1 MSB), @2 mult1, @3 mult2
						; @4 Hilfsreg
						; mult1 0...255, mult2 0...255
						; result 0...65025
						; 6-86 cycles 24 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
 	clr @0		; clr result
	clr @1
	clr @4		; clr Hilfsregister
	tst @2
	breq PC+8	; Ende
	lsr @2		; untere bit von mult1 testen
	brcc PC+3	; add ueberspringen
	add @0,@3
	adc @1,@4
	lsl @3
	rol @4
	rjmp PC-8
.endm

.macro multsoft_8x16_24	; @0-2 result (@2 MSB), @3 mult1
						; @4,5 mult2 (@5 MSB), @6 Hilfsreg
						; mult1 0...255
						; mult2 0...65535 
						; result 0...16711425
						; 7-103 cycles 30 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @6	; clr Hilfsregister
	tst @3	; mult1 = 0?
	breq PC+10	; Ende
	lsr @3		; untere bit von mult1 testen
	brcc PC+4	; add ueberspringen
	add @0,@4	; mult2 zu result addieren
	adc @1,@5
	adc @2,@6
	lsl @4		; mult2 x2
	rol @5
	rol @6
	rjmp PC-10
.endm

.macro multsoft_8x24_32	; @0-3 result (@3 MSB), @4 mult1
						; @5-7 mult2 (@7 MSB), @8 Hilfsreg
						; mult1 0...255
						; mult2 0...16777215
						; result 0...4278189825
						; 8-120 cycles 36 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @8	; clr Hilfsregister
	tst @4	; mult1 = 0?
	breq PC+12	; Ende
	lsr @4		; untere bit von mult1 testen
	brcc PC+5	; add ueberspringen
	add @0,@5
	adc @1,@6
	adc @2,@7
	adc @3,@8
	lsl @5		; mult2 x2
	rol @6
	rol @7
	rol @8
	rjmp PC-12
.endm

.macro multsoft_8x32_40	; @0-4 result (@4 MSB), @5 mult1
						; @6-9 mult2 (@9 MSB), @10 Hilfsreg
						; mult1 0...255
						; mult2 0...4294967295
						; result 0...1095216660225
						; 9-137 cycles 42 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @10	; clr Hilfsregister
	tst @5	; mult1 = 0?
	breq PC+14	; Ende
	lsr @5		; untere bit von mult1 testen
	brcc PC+6	; add ueberspringen
	add @0,@6
	adc @1,@7
	adc @2,@8
	adc @3,@9
	adc @4,@10
	lsl @6		; mult2 x2
	rol @7
	rol @8
	rol @9
	rol @10
	rjmp PC-14
.endm

.macro multsoft_8x40_48	; @0-5 result (@5 MSB), @6 mult1
						; @7-11 mult2 (@11 MSB), @12 Hilfsreg
						; mult1 0...255
						; mult2 0...1099511627775
						; result 0...280375465082625
						; 10-154 cycles 48 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @12	; clr Hilfsregister
	tst @6	; mult1 = 0?
	breq PC+16	; Ende
	lsr @6		; untere bit von mult1 testen
	brcc PC+7	; add ueberspringen
	add @0,@7
	adc @1,@8
	adc @2,@9
	adc @3,@10
	adc @4,@11
	adc @5,@12
	lsl @7		; mult2 x2
	rol @8
	rol @9
	rol @10
	rol @11
	rol @12
	rjmp PC-16
.endm

.macro multsoft_8x48_56	; @0-6 result (@6 MSB), @7 mult1
						; @8-13 mult2 (@13 MSB), @14 Hilfsreg
						; mult1 0...255
						; mult2 0...281474976710655
						; result 0...71776119061217025
						; 11-171 cycles 54 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @14	; clr Hilfsregister
	tst @7	; mult1 = 0?
	breq PC+18	; Ende
	lsr @7		; untere bit von mult1 testen
	brcc PC+8	; add ueberspringen
	add @0,@8
	adc @1,@9
	adc @2,@10
	adc @3,@11
	adc @4,@12
	adc @5,@13
	adc @6,@14
	lsl @8		; mult2 x2
	rol @9
	rol @10
	rol @11
	rol @12
	rol @13
	rol @14
	rjmp PC-18
.endm

.macro multsoft_8x56_64	; @0-7 result (@7 MSB), @8 mult1
						; @9-15 mult2 (@15 MSB), @16 Hilfsreg
						; mult1 0...255
						; mult2 0...72057594037927935
						; result 0...18374686479671623425
						; 12-188 cycles 60 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=255
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @7
	clr @16	; clr Hilfsregister
	tst @8	; mult1 = 0?
	breq PC+20	; Ende
	lsr @8		; untere bit von mult1 testen
	brcc PC+9	; add ueberspringen
	add @0,@9
	adc @1,@10
	adc @2,@11
	adc @3,@12
	adc @4,@13
	adc @5,@14
	adc @6,@15
	adc @7,@16
	lsl @9		; mult2 x2
	rol @10
	rol @11
	rol @12
	rol @13
	rol @14
	rol @15
	rol @16
	rjmp PC-20
.endm

.macro multsoft_16x16_32	; @0-3 result (@3 MSB), @4,5 mult1 (@5 MSB)
						; @6,7 mult2 (@7 MSB), @8,9 Hilfsreg
						; mult1 0...65535
						; mult2 0...65535 
						; result 0...4294836225
						; 11-267 cycles 44 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=65535
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @8	; clr Hilfsregister
	clr @9
	tst @4		; mult1 = 0?
	brne PC+3	; weiter machen
	tst @5
	breq PC+13	; Ende
	lsr @5		; untere bit von mult1 testen
	ror @4
	brcc PC+5	; add ueberspringen
	add @0,@6
	adc @1,@7
	adc @2,@8
	adc @3,@9
	lsl @6		; mult2 x2
	rol @7
	rol @8
	rol @9
	rjmp PC-15
.endm

.macro multsoft_16x24_40	; @0-4 result (@4 MSB), @5,6 mult1 (@6 MSB)
						; @7-9 mult2 (@9 MSB), @10,11 Hilfsreg
						; mult1 0...65535
						; mult2 0...16777215 
						; result 0...1099494785025
						; 12-300 cycles 50 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=65535
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @10	; clr Hilfsregister
	clr @11
	tst @5		; mult1 = 0?
	brne PC+3	; weiter machen
	tst @6
	breq PC+15	; Ende
	lsr @6		; untere bit von mult1 testen
	ror @5
	brcc PC+6	; add ueberspringen
	add @0,@7
	adc @1,@8
	adc @2,@9
	adc @3,@10
	adc @4,@11
	lsl @7		; mult2 x2
	rol @8
	rol @9
	rol @10
	rol @11
	rjmp PC-17
.endm

.macro multsoft_16x32_48	; @0-5 result (@5 MSB), @6,7 mult1 (@7 MSB)
						; @8-11 mult2 (@11 MSB), @12,13 Hilfsreg
						; mult1 0...65535
						; mult2 0...4294967295
						; result 0...281470681677825
						; 13-333 cycles 56 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=65535
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @12	; clr Hilfsregister
	clr @13
	tst @6		; mult1 = 0?
	brne PC+3	; weiter machen
	tst @7
	breq PC+17	; Ende
	lsr @7		; untere bit von mult1 testen
	ror @6
	brcc PC+7	; add ueberspringen
	add @0,@8
	adc @1,@9
	adc @2,@10
	adc @3,@11
	adc @4,@12
	adc @5,@13
	lsl @8		; mult2 x2
	rol @9
	rol @10
	rol @11
	rol @12
	rol @13
	rjmp PC-19
.endm

.macro multsoft_16x40_56	; @0-6 result (@6 MSB), @7,8 mult1 (@8 MSB)
						; @9-13 mult2 (@13 MSB), @14,15 Hilfsreg
						; mult1 0...65535
						; mult2 0...1099511627775
						; result 0...72056494526234625
						; 14-366 cycles 62 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=65535
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @14	; clr Hilfsregister
	clr @15
	tst @7		; mult1 = 0?
	brne PC+3	; weiter machen
	tst @8
	breq PC+19	; Ende
	lsr @8		; untere bit von mult1 testen
	ror @7
	brcc PC+8	; add ueberspringen
	add @0,@9
	adc @1,@10
	adc @2,@11
	adc @3,@12
	adc @4,@13
	adc @5,@14
	adc @6,@15
	lsl @9		; mult2 x2
	rol @10
	rol @11
	rol @12
	rol @13
	rol @14
	rol @15
	rjmp PC-21
.endm

.macro multsoft_16x48_64	; @0-7 result (@7 MSB), @8,9 mult1 (@9 MSB)
						; @10-15 mult2 (@13 MSB), @16,17 Hilfsreg
						; mult1 0...65535
						; mult2 0...281474976710655
						; result 0...18446462598732775425
						; 15-399 cycles 68 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=65535
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @7
	clr @16	; clr Hilfsregister
	clr @17
	tst @8		; mult1 = 0?
	brne PC+3	; weiter machen
	tst @9
	breq PC+21	; Ende
	lsr @9		; untere bit von mult1 testen
	ror @8
	brcc PC+9	; add ueberspringen
	add @0,@10
	adc @1,@11
	adc @2,@12
	adc @3,@13
	adc @4,@14
	adc @5,@15
	adc @6,@16
	adc @7,@17
	lsl @10		; mult2 x2
	rol @11
	rol @12
	rol @13
	rol @14
	rol @15
	rol @16
	rol @17
	rjmp PC-23
.endm

.macro multsoft_24x24_48	; @0-5 result (@5 MSB), @6-8 mult1 (@8 MSB)
						; @9-11 mult2 (@9 MSB), @12-14 Hilfsreg
						; mult1 0...16777215
						; mult2 0...16777215 
						; result 0...281474943156225
						; 16-520 cycles 64 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=16777215
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @12	; clr Hilfsregister
	clr @13
	clr @14
	tst @6		; mult1 = 0?
	brne PC+5	; weiter machen
	tst @7
	brne PC+3	; weiter machen
	tst @8
	breq PC+18	; Ende
	lsr @8		; untere bit von mult1 testen
	ror @7
	ror @6
	brcc PC+7	; add ueberspringen
	add @0,@9
	adc @1,@10
	adc @2,@11
	adc @3,@12
	adc @4,@13
	adc @5,@14
	lsl @9		; mult2 x2
	rol @10
	rol @11
	rol @12
	rol @13
	rol @14
	rjmp PC-22
.endm

.macro multsoft_24x32_56	; @0-6 result (@6 MSB), @7-9 mult1 (@9 MSB)
						; @10-13 mult2 (@13 MSB), @14-16 Hilfsreg
						; mult1 0...16777215
						; mult2 0...4294967295
						; result 0...72057589726183425
						; 17-569 cycles 70 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=16777215
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @14	; clr Hilfsregister
	clr @15
	clr @16
	tst @7		; mult1 = 0?
	brne PC+5	; weiter machen
	tst @8
	brne PC+3	; weiter machen
	tst @9
	breq PC+20	; Ende
	lsr @9		; untere bit von mult1 testen
	ror @8
	ror @7
	brcc PC+8	; add ueberspringen
	add @0,@10
	adc @1,@11
	adc @2,@12
	adc @3,@13
	adc @4,@14
	adc @5,@15
	adc @6,@16
	lsl @10		; mult2 x2
	rol @11
	rol @12
	rol @13
	rol @14
	rol @15
	rol @16
	rjmp PC-24
.endm

.macro multsoft_24x40_64	; @0-7 result (@7 MSB), @8-10 mult1 (@10 MSB)
						; @11-15 mult2 (@15 MSB), @16-18 Hilfsreg
						; mult1 0...16777215
						; mult2 0...1099511627775
						; result 0...18446742974181146625
						; 18-618 cycles 76 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=16777215
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @7
	clr @16	; clr Hilfsregister
	clr @17
	clr @18
	tst @8		; mult1 = 0?
	brne PC+5	; weiter machen
	tst @9
	brne PC+3	; weiter machen
	tst @10
	breq PC+22	; Ende
	lsr @10		; untere bit von mult1 testen
	ror @9
	ror @8
	brcc PC+9	; add ueberspringen
	add @0,@11
	adc @1,@12
	adc @2,@13
	adc @3,@14
	adc @4,@15
	adc @5,@16
	adc @6,@17
	adc @7,@18
	lsl @11		; mult2 x2
	rol @12
	rol @13
	rol @14
	rol @15
	rol @16
	rol @17
	rol @18
	rjmp PC-26
.endm

.macro multsoft_32x32_64	; @0-7 result (@7 MSB), @8-11 mult1 (@11 MSB)
						; @12-15 mult2 (@15 MSB), @16-19 Hilfsreg
						; mult1 0...4294967295
						; mult2 0...4294967295 
						; result 0...18446744065119617025
						; 21-853 cycles 84 bytes
						; min.cycles wenn mult1=0
						; max.cycles wenn mult1=4294967295
	clr @0	; clr result
	clr @1
	clr @2
	clr @3
	clr @4
	clr @5
	clr @6
	clr @7
	clr @16	; clr Hilfsregister
	clr @17
	clr @18
	clr @19
	tst @8		; mult1 = 0?
	brne PC+7	; weiter machen
	tst @9
	brne PC+5	; weiter machen
	tst @10
	brne PC+3	; weiter machen
	tst @11
	breq PC+23	; Ende
	lsr @11		; untere bit von mult1 testen
	ror @10
	ror @9
	ror @8
	brcc PC+9	; add ueberspringen
	add @0,@12
	adc @1,@13
	adc @2,@14
	adc @3,@15
	adc @4,@16
	adc @5,@17
	adc @6,@18
	adc @7,@19
	lsl @12		; mult2 x2
	rol @13
	rol @14
	rol @15
	rol @16
	rol @17
	rol @18
	rol @19
	rjmp PC-29
.endm

;=================================================================================
;=== NEG-Macro ===================================================================
;=================================================================================
#ifndef _NEGXX_
#define _NEGXX_

.macro neg16	; @0,1 Data (@1 MSB), @2 temp, 5c,10b
	clr @2
	com @0
	com @1
	adc @0,@2
	adc @1,@2
.endm

.macro neg24	; @0-2 Data (@2 MSB), @3 temp, 7c,14b
	clr @3
	com @0
	com @1
	com @2
	adc @0,@3
	adc @1,@3
	adc @2,@3
.endm

.macro neg32	; @0-3 Data (@3 MSB), @4 temp, 9c,18b
	clr @4
	com @0
	com @1
	com @2
	com @3
	adc @0,@4
	adc @1,@4
	adc @2,@4
	adc @3,@4
.endm

.macro neg40	; @0-4 Data (@4 MSB), @5 temp, 11c,22b
	clr @5
	com @0
	com @1
	com @2
	com @3
	com @4
	adc @0,@5
	adc @1,@5
	adc @2,@5
	adc @3,@5
	adc @4,@5
.endm

.macro neg48	; @0-5 Data (@5 MSB), @6 temp, 13c,26b
	clr @6
	com @0
	com @1
	com @2
	com @3
	com @4
	com @5
	adc @0,@6
	adc @1,@6
	adc @2,@6
	adc @3,@6
	adc @4,@6
	adc @5,@6
.endm

.macro neg56	; @0-6 Data (@6 MSB), @7 temp, 15c,30b
	clr @7
	com @0
	com @1
	com @2
	com @3
	com @4
	com @5
	com @6
	adc @0,@7
	adc @1,@7
	adc @2,@7
	adc @3,@7
	adc @4,@7
	adc @5,@7
	adc @6,@7
.endm

.macro neg64	; @0-7 Data (@7 MSB), @8 temp, 17c,34b
	clr @8
	com @0
	com @1
	com @2
	com @3
	com @4
	com @5
	com @6
	com @7
	adc @0,@8
	adc @1,@8
	adc @2,@8
	adc @3,@8
	adc @4,@8
	adc @5,@8
	adc @6,@8
	adc @7,@8
.endm

#endif /* _NEGXX_ */

;=================================================================================
;=== mul signed ==================================================================
;=================================================================================

.macro multsoft_8x8_16_s	; @0,1 result (@1 MSB), @2 mult1
						; @3 mult2, @4 Hilfsreg
						; mult1 -128...127, mult2 -128...127
						; result -16256...16384
						; 15-94 cycles, 62 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=-128 und mult2>0
	
 	clr @0
	tst @2
	brpl  mn1
	inc @0
	neg @2
 mn1:
 	tst @3
	brpl mn2
	inc @0
	neg @3
 mn2:
 	bst	@0,0

	multsoft_8x8_16 @0,@1,@2,@3,@4
	
	brtc end
	multsoft_neg16 @0,@1,@4
 end:
.endm




.macro multsoft_8x16_24_s	; @0-2 result (@2 MSB), @3 mult1
						; @4,5 mult2 (@5 MSB), @6 Hilfsreg
						; mult1 -128...127
						; mult2 -32768...32767
						; result -4194176...4194304
						; 16-115 cycles, 82 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0
	
  	clr @0
	tst @3
	brpl  mn1
	inc @0
	neg @3
 mn1:
 	tst @5
	brpl mn2
	inc @0
	neg16 @4,@5,@6
 mn2:
 	bst	@0,0

	multsoft_8x16_24 @0,@1,@2,@3,@4,@5,@6
	
	brtc end
	neg24 @0,@1,@2,@6
 end:
.endm




.macro multsoft_8x24_32_s	; @0-3 result (@3 MSB), @4 mult1
						; @5-7 mult2 (@7 MSB), @8 Hilfsreg
						; mult1 -128...127
						; mult2 -8388608...8388607
						; result -1073741696...1073741824
						; 17-134 cycles, 96 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0
	
  	clr @0
	tst @4
	brpl  mn1
	inc @0
	neg @4
 mn1:
 	tst @7
	brpl mn2
	inc @0
	neg24 @5,@6,@7,@8
 mn2:
 	bst	@0,0

	multsoft_8x24_32 @0,@1,@2,@3,@4,@5,@6,@7,@8
	
	brtc end
	neg32 @0,@1,@2,@3,@8
 end:
.endm




.macro multsoft_8x32_40_s	; @0-4 result (@4 MSB), @5 mult1
						; @6-9 mult2 (@9 MSB), @10 Hilfsreg
						; mult1 -128...127
						; mult2 -2147483648...2147483647
						; result -274877906816...274877906944
						; 18-153 cycles, 110 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0 
  	clr @0
	tst @5
	brpl mn1
	inc @0
	neg @5
 mn1:
 	tst @9
	brpl mn2
	inc @0
	neg32 @6,@7,@8,@9,@10
 mn2:
 	bst	@0,0

	multsoft_8x32_40 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_8x40_48_s	; @0-5 result (@5 MSB), @6 mult1
						; @7-11 mult2 (@11 MSB), @12 Hilfsreg
						; mult1 -128...127
						; mult2 -549755813888...549755813887
						; result -70368744177536...70368744177664
						; 19-172 cycles, 124 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0 
  	clr @0
	tst @6
	brpl mn1
	inc @0
	neg @6
 mn1:
 	tst @11
	brpl mn2
	inc @0
	neg40 @7,@8,@9,@10,@11,@12
 mn2:
 	bst	@0,0

	multsoft_8x40_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_8x48_56_s	; @0-6 result (@6 MSB), @7 mult1
						; @8-13 mult2 (@13 MSB), @14 Hilfsreg
						; mult1 -128...127
						; mult2 -140737488355328...140737488355327
						; result -18014398509481856...18014398509481984
						; 20-191 cycles, 138 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0 
  	clr @0
	tst @7
	brpl mn1
	inc @0
	neg @7
 mn1:
 	tst @13
	brpl mn2
	inc @0
	neg48 @8,@9,@10,@11,@12,@13,@14
 mn2:
 	bst	@0,0

	multsoft_8x48_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_8x56_64_s	; @0-7 result (@7 MSB), @8 mult1
						; @9-15 mult2 (@15 MSB), @16 Hilfsreg
						; mult1 -128...127
						; mult2 -36028797018963968...36028797018963967
						; result -4611686018427387776...4611686018427387904
						; 21-210 cycles, 152 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=127 und mult2<0 
  	clr @0
	tst @8
	brpl mn1
	inc @0
	neg @8
 mn1:
 	tst @15
	brpl mn2
	inc @0
	neg56 @9,@10,@11,@12,@13,@14,@15,@16
 mn2:
 	bst	@0,0

	multsoft_8x56_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_16x16_32_s	; @0-3 result (@3 MSB), @4,5 mult1 (@5 MSB)
						; @6,7 mult2 (@7 MSB), @8,9 Hilfsreg
						; mult1 -32768...32767
						; mult2 -32768...32767 
						; result -1073709056...1073741824
						; 20-277 cycles, 110 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=32767 und mult2<0 
 	clr @0
	tst @5
	brpl  mn1
	inc @0
	neg16 @4,@5,@8
 mn1:
 	tst @7
	brpl mn2
	inc @0
	neg16 @6,@7,@8
 mn2:
 	bst	@0,0


	multsoft_16x16_32 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9
	
	brtc end
	neg32 @0,@1,@2,@3,@8
 end:
.endm




.macro multsoft_16x24_40_s	; @0-4 result (@4 MSB), @5,6 mult1 (@6 MSB)
						; @7-9 mult2 (@9 MSB), @10,11 Hilfsreg
						; mult1 -32768...32767
						; mult2 -8388608...8388607
						; result -274877874176...274877906944
						; 21-312 cycles, 124 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=32767 und mult2<0 
  	clr @0
	tst @6
	brpl mn1
	inc @0
	neg16 @5,@6,@10
 mn1:
 	tst @9
	brpl mn2
	inc @0
	neg24 @7,@8,@9,@10
 mn2:
 	bst	@0,0

	multsoft_16x24_40 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_16x32_48_s	; @0-5 result (@5 MSB), @6,7 mult1 (@7 MSB)
						; @8-11 mult2 (@11 MSB), @12,13 Hilfsreg
						; mult1 -32768...32767
						; mult2 -2147483648...2147483647
						; result -70368744144896...70368744177664
						; 22-347 cycles, 138 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=32767 und mult2<0 
 	clr @0
	tst @7
	brpl mn1
	inc @0
	neg16 @6,@7,@12
 mn1:
 	tst @11
	brpl mn2
	inc @0
	neg32 @8,@9,@10,@11,@12
 mn2:
 	bst	@0,0

	multsoft_16x32_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_16x40_56_s	; @0-6 result (@6 MSB), @7,8 mult1 (@8 MSB)
						; @9-13 mult2 (@13 MSB), @14,15 Hilfsreg
						; mult1 -32768...32767
						; mult2 -549755813888...549755813887
						; result -18014398509449216...18014398509481984
						; 23-382 cycles, 152 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=32767 und mult2<0 
  	clr @0
	tst @8
	brpl mn1
	inc @0
	neg16 @7,@8,@14
 mn1:
 	tst @13
	brpl mn2
	inc @0
	neg40 @9,@10,@11,@12,@13,@14
 mn2:
 	bst	@0,0

	multsoft_16x40_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_16x48_64_s	; @0-7 result (@7 MSB), @8,9 mult1 (@9 MSB)
						; @10-15 mult2 (@13 MSB), @16,17 Hilfsreg
						; mult1 -32768...32767
						; mult2 -140737488355328...140737488355327
						; result -4611686018427355136...4611686018427387904
						; 24-417 cycles, 166 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=32767 und mult2<0 
  	clr @0
	tst @9
	brpl mn1
	inc @0
	neg16 @8,@9,@16
 mn1:
 	tst @15
	brpl mn2
	inc @0
	neg48 @10,@11,@12,@13,@14,@15,@16
 mn2:
 	bst	@0,0

	multsoft_16x48_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_24x24_48_s	; @0-5 result (@5 MSB), @6-8 mult1 (@8 MSB)
						; @9-11 mult2 (@9 MSB), @12-14 Hilfsreg
						; mult1 -8388608...8388607
						; mult2 -8388608...8388607
						; result -70368735789056...70368744177664
						; 25-531 cycles, 146 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=8388607 und mult2<0 
  	clr @0
	tst @8
	brpl mn1
	inc @0
	neg24 @6,@7,@8,@12
 mn1:
 	tst @11
	brpl mn2
	inc @0
	neg24 @9,@10,@11,@12
 mn2:
 	bst	@0,0

	multsoft_24x24_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_24x32_56_s	; @0-6 result (@6 MSB), @7-9 mult1 (@9 MSB)
						; @10-13 mult2 (@13 MSB), @14-16 Hilfsreg
						; mult1 -8388608...8388607
						; mult2 -2147483648...2147483647
						; result -18014398501093376...18014398509481984
						; 26-582 cycles, 160 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=8388607 und mult2<0 
  	clr @0
	tst @9
	brpl mn1
	inc @0
	neg24 @7,@8,@9,@14
 mn1:
 	tst @13
	brpl mn2
	inc @0
	neg32 @10,@11,@12,@13,@14
 mn2:
 	bst	@0,0

	multsoft_24x32_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_24x40_64_s	; @0-7 result (@7 MSB), @8-10 mult1 (@10 MSB)
						; @11-15 mult2 (@15 MSB), @16-18 Hilfsreg
						; mult1 -8388608...8388607
						; mult2 -549755813888...549755813887
						; result -4611686018418999296...4611686018427387904
						; 27-633 cycles, 174 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=8388607 und mult2<0
  	clr @0
	tst @10
	brpl mn1
	inc @0
	neg24 @8,@9,@10,@16
 mn1:
 	tst @15
	brpl mn2
	inc @0
	neg40 @11,@12,@13,@14,@15,@16
 mn2:
 	bst	@0,0

	multsoft_24x40_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17,@18
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_32x32_64_s	; @0-7 result (@7 MSB), @8-11 mult1 (@11 MSB)
						; @12-15 mult2 (@15 MSB), @16-19 Hilfsreg
						; mult1 -2147483648...2147483647
						; mult2 -2147483648...2147483647
						; result -4611686016279904256...4611686018427387904
						; 30-865 cycles, 182 bytes
						; min.cycles wenn mult1=0 und mult2>0
						; max.cycles wenn mult1=2147483647 und mult2<0
  	clr @0
	tst @11
	brpl mn1
	inc @0
	neg32 @8,@9,@10,@11,@16
 mn1:
 	tst @15
	brpl mn2
	inc @0
	neg32 @12,@13,@14,@15,@16
 mn2:
 	bst	@0,0

	multsoft_32x32_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17,@18,@19
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm

;=================================================================================
;=== mul signed/unsigned =========================================================
;=================================================================================
.macro multsoft_8x8_16_su	; @0,1 result (@1 MSB), @2 mult_s
						; @3 mult_u, @4 Hilfsreg
						; mult_s -128...127
						; mult_u 0...255
						; result -32640...32385
						; 12-91 cycles, 48 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-128
	clt			; mult_s Zeichen
	sbrs @2,7
	rjmp mn1
	set
	neg @2
 mn1:

	multsoft_8x8_16 @0,@1,@2,@3,@4
	
	brtc end
	neg16 @0,@1,@4
 end:
.endm




.macro multsoft_8x16_24_su	; @0-2 result (@2 MSB), @3 mult_s
						; @4,5 mult_u (@5 MSB), @6 Hilfsreg
						; mult_s -128...127
						; mult_u 0...65535
						; result -8388480...8322945
						; 13-105 cycles, 58 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-127
	clt			; mult_s Zeichen
	sbrs @3,7
	rjmp mn1
	set
	neg @3
 mn1:

	multsoft_8x16_24 @0,@1,@2,@3,@4,@5,@6
	
	brtc end
	neg24 @0,@1,@2,@6
 end:
.endm




.macro multsoft_8x24_32_su	; @0-3 result (@3 MSB), @4 mult_s
						; @5-7 mult_u (@7 MSB), @8 Hilfsreg
						; mult_s -128...127
						; mult_u 0...16777215
						; result -2147483520...2130706305
						; 14-122 cycles, 68 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-127
	clt			; mult_s Zeichen
	sbrs @4,7
	rjmp mn1
	set
	neg @4
 mn1:

	multsoft_8x24_32 @0,@1,@2,@3,@4,@5,@6,@7,@8
	
	brtc end
	neg32 @0,@1,@2,@3,@8
 end:
.endm




.macro multsoft_8x32_40_su	; @0-4 result (@4 MSB), @5 mult_s
						; @6-9 mult_u (@9 MSB), @10 Hilfsreg
						; mult_s -128...127
						; mult_u 0...4294967295
						; result -549755813760...545460846465
						; 15-139 cycles, 78 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-127
	clt			; mult_s Zeichen
	sbrs @5,7
	rjmp mn1
	set
	neg @5
 mn1:

	multsoft_8x32_40 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_8x40_48_su	; @0-5 result (@5 MSB), @6 mult_s
						; @7-11 mult_u (@11 MSB), @12 Hilfsreg
						; mult_s -128...127
						; mult_u 0...1099511627775
						; result -140737488355200...139637976727425
						; 16-142 cycles, 88 bytes
						; min.cycles wenn mult_s=0
						; 
	clt			; mult_s Zeichen
	sbrs @6,7
	rjmp mn1
	set
	neg @6
 mn1:

	multsoft_8x40_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_8x48_56_su	; @0-6 result (@6 MSB), @7 mult_s
						; @8-13 mult_u (@13 MSB), @14 Hilfsreg
						; mult_s -128...127
						; mult_u 0...281474976710655
						; result -36028797018963840...35747322042253185
						; 17-173 cycles, 98 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-127
	clt			; mult_s Zeichen
	sbrs @7,7
	rjmp mn1
	set
	neg @7
 mn1:

	multsoft_8x48_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_8x56_64_su	; @0-7 result (@7 MSB), @8 mult_s
						; @9-15 mult_u (@15 MSB), @16 Hilfsreg
						; mult_s -128...127
						; mult_u 0...72057594037927935
						; result -9223372036854775680...9151314442816847745
						; 18-190 cycles, 108 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-127
	clt			; mult_s Zeichen
	sbrs @8,7
	rjmp mn1
	set
	neg @8
 mn1:

	multsoft_8x56_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_16x8_24_su	; @0-2 result (@2 MSB), @3,@4 mult_s (@4 MSB)
						; @5 mult_u, @6 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...255
						; result -8355840...8355585
						; 13-122 cycles, 68 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=255 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @4,7
	rjmp mn1
	set
	neg16 @3,@4,@6
 mn1:

	multsoft_8x16_24 @0,@1,@2,@5,@3,@4,@6
	
	brtc end
	neg24 @0,@1,@2,@6
 end:
.endm




.macro multsoft_16x16_32_su	; @0-3 result (@3 MSB), @4,5 mult_s (@5 MSB)
						; @6,7 mult_u (@7 MSB), @8,9 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...65535
						; result -2147450880...2147385345
						; 17-272 cycles, 86 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-32767
	clt			; mult_s Zeichen
	sbrs @5,7
	rjmp mn1
	set
	neg16 @4,@5,@8
 mn1:

	multsoft_16x16_32 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9
	
	brtc end
	neg32 @0,@1,@2,@3,@8
 end:
.endm




.macro multsoft_16x24_40_su	; @0-4 result (@4 MSB), @5,6 mult_s (@6 MSB)
						; @7-9 mult_u (@9 MSB), @10,11 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...16777215
						; result -549755781120...549739003905
						; 18-305 cycles, 96 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-32767
	clt			; mult_s Zeichen
	sbrs @6,7
	rjmp mn1
	set
	neg16 @5,@6,@10
 mn1:

	multsoft_16x24_40 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_16x32_48_su	; @0-5 result (@5 MSB), @6,7 mult_s (@7 MSB)
						; @8-11 mult_u (@11 MSB), @12,13 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...4294967295
						; result -140737488322560...140733193355265
						; 19-338 cycles, 106 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-32767
	clt			; mult_s Zeichen
	sbrs @7,7
	rjmp mn1
	set
	neg16 @6,@7,@12
 mn1:

	multsoft_16x32_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_16x40_56_su	; @0-6 result (@6 MSB), @7,8 mult_s (@8 MSB)
						; @9-13 mult_u (@13 MSB), @14,15 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...1099511627775
						; result -36028797018931200...36027697507303425
						; 20-371 cycles, 116 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-32767
	clt			; mult_s Zeichen
	sbrs @8,7
	rjmp mn1
	set
	neg16 @7,@8,@14
 mn1:

	multsoft_16x40_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_16x48_64_su	; @0-7 result (@7 MSB), @8,9 mult_s (@9 MSB)
						; @10-15 mult_u (@15 MSB), @16,17 Hilfsreg
						; mult_s -32768...32767
						; mult_u 0...281474976710655
						; result -9223372036854743040...9223090561878032385
						; 21-404 cycles, 126 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-32767
	clt			; mult_s Zeichen
	sbrs @9,7
	rjmp mn1
	set
	neg16 @8,@9,@16
 mn1:

	multsoft_16x48_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_24x8_32_su	; @0-3 result (@3 MSB), @4-6 mult_s (@6 MSB)
						; @7 mult_u, @8 Hilfsreg
						; mult_s -8388608...8388607
						; mult_u 0...255
						; result -2139095040...2139094785
						; 14-143 cycles, 126 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=256 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @6,7
	rjmp mn1
	set
	neg24 @4,@5,@6,@8
  mn1:

	multsoft_8x24_32 @0,@1,@2,@3,@7,@4,@5,@6,@8
	
	brtc end
	neg32 @0,@1,@2,@3,@8
 end:
.endm




.macro multsoft_24x16_40_su	; @0-4 result (@4 MSB), @5-7 mult_s (@7 MSB)
						; @8,9 mult_u (@9 MSB), @10,11 Hilfsreg
						; mult_s -8388608...8388607
						; mult_u 0...65535
						; result -549747425280...549747359745
						; 18-325 cycles, 100 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=65535 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @7,7
	rjmp mn1
	set
	neg24 @5,@6,@7,@10
  mn1:

	multsoft_16x24_40 @0,@1,@2,@3,@4,@8,@9,@5,@6,@7,@10,@11
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_24x24_48_su	; @0-5 result (@5 MSB), @6-8 mult_s (@8 MSB)
						; @9-11 mult_u (@11 MSB), @12-14 Hilfsreg
						; mult_s -8388608...8388607
						; mult_u 0...16777215
						; result -140737479966720...140737463189505
						; 22-526 cycles, 118 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-8388607
	clt			; mult_s Zeichen
	sbrs @8,7
	rjmp mn1
	set
	neg24 @6,@7,@8,@12
  mn1:

	multsoft_24x24_48 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_24x32_56_su	; @0-6 result (@6 MSB), @7-9 mult_s (@9 MSB)
						; @10-13 mult_u (@13 MSB), @14-16 Hilfsreg
						; mult_s -8388608...8388607
						; mult_u 0...4294967295
						; result -36028797010575360...36028792715608065
						; 23-575 cycles, 128 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-8388607
	clt			; mult_s Zeichen
	sbrs @9,7
	rjmp mn1
	set
	neg24 @7,@8,@9,@14
  mn1:

	multsoft_24x32_56 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_24x40_64_su	; @0-7 result (@7 MSB), @8-10 mult_s (@10 MSB)
						; @11-15 mult_u (@15 MSB), @16-18 Hilfsreg
						; mult_s -8388608...8388607
						; mult_u 0...1099511627775
						; result -9223372036846387200...9223370937334759425
						; 24-624 cycles, 138 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-8388607
	clt			; mult_s Zeichen
	sbrs @10,7
	rjmp mn1
	set
	neg24 @8,@9,@10,@16
  mn1:

	multsoft_24x40_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17,@18
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_32x8_40_su	; @0-4 result (@4 MSB), @5-8 mult_s (@8 MSB)
						; @9 mult_u, @10 Hilfsreg
						; mult_s -2147483648...2147483647
						; mult_u 0...255
						; result -547608330240...547608329985
						; 15-164 cycles, 96 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=255 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @8,7
	rjmp mn1
	set
	neg32 @5,@6,@7,@8,@10
  mn1:

	multsoft_8x32_40 @0,@1,@2,@3,@4,@9,@5,@6,@7,@8,@10
	
	brtc end
	neg40 @0,@1,@2,@3,@4,@10
 end:
.endm




.macro multsoft_32x16_48_su	; @0-5 result (@5 MSB), @6-9 mult_s (@9 MSB)
						; @10,11 mult_u (@11 MSB), @12,13 Hilfsreg
						; mult_s -2147483648...2147483647
						; mult_u 0...65535
						; result -140735340871680...140735340806145
						; 19-362 cycles, 114 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=65535 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @9,7
	rjmp mn1
	set
	neg32 @6,@7,@8,@9,@12
  mn1:

	multsoft_16x32_48 @0,@1,@2,@3,@4,@5,@10,@11,@6,@7,@8,@9,@12,@13
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_32x24_56_su	; @0-6 result (@6 MSB), @7-10 mult_s (@10 MSB)
						; @11-13 mult_u (@13 MSB), @14-16 Hilfsreg
						; mult_s -2147483648...2147483647
						; mult_u 0...16777215
						; result -36028794871480320...36028794854703105
						; 23-600 cycles, 132 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=2147483647 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @10,7
	rjmp mn1
	set
	neg32 @7,@8,@9,@10,@14
  mn1:

	multsoft_24x32_56 @0,@1,@2,@3,@4,@5,@6,@11,@12,@13,@7,@8,@9,@10,@14,@15,@16
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_32x32_64_su	; @0-7 result (@7 MSB), @8-11 mult_s (@11 MSB)
						; @12-15 mult_u (@15 MSB), @16-19 Hilfsreg
						; mult_s -2147483648...2147483647
						; mult_u 0...4294967295
						; result -9223372034707292160...9223372030412324865
						; 27-860 cycles, 150 bytes
						; min.cycles wenn mult_s=0
						; max.cycles wenn mult_s=-2147483647
	clt			; mult_s Zeichen
	sbrs @11,7
	rjmp mn1
	set
	neg32 @8,@9,@10,@11,@16
  mn1:

	multsoft_32x32_64 @0,@1,@2,@3,@4,@5,@6,@7,@8,@9,@10,@11,@12,@13,@14,@15,@16,@17,@18,@19
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_40x8_48_su	; @0-5 result (@5 MSB), @6-10 mult_s (@10 MSB)
						; @11 mult_u, @12 Hilfsreg
						; mult_s -549755813888...549755813887
						; mult_u 0...255
						; result -140187732541440...140187732541185
						; 16-185 cycles, 110 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=255 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @10,7
	rjmp mn1
	set
	neg40 @6,@7,@8,@9,@10,@12
  mn1:

	multsoft_8x40_48 @0,@1,@2,@3,@4,@5,@11,@6,@7,@8,@9,@10,@12
	
	brtc end
	neg48 @0,@1,@2,@3,@4,@5,@12
 end:
.endm




.macro multsoft_40x16_56_su	; @0-6 result (@6 MSB), @7-11 mult_s (@11 MSB)
						; @12,13 mult_u (@13 MSB), @14,15 Hilfsreg
						; mult_s -549755813888...549755813887
						; mult_u 0...65535
						; result -36028247263150080...36028247263084545
						; 20-399 cycles, 128 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=65535 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @11,7
	rjmp mn1
	set
	neg40 @7,@8,@9,@10,@11,@14
  mn1:

	multsoft_16x40_56 @0,@1,@2,@3,@4,@5,@6,@12,@13,@7,@8,@9,@10,@11,@14,@15
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_40x24_64_su	; @0-7 result (@7 MSB), @8-12 mult_s (@12 MSB)
						; @13-15 mult_u (@15 MSB), @16-18 Hilfsreg
						; mult_s -549755813888...549755813887
						; mult_u 0...16777215
						; result -9223371487098961920...9223371487082184705
						; 24-653 cycles, 146 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=16777215 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @12,7
	rjmp mn1
	set
	neg40 @8,@9,@10,@11,@12,@16
  mn1:

	multsoft_24x40_64 @0,@1,@2,@3,@4,@5,@6,@7,@13,@14,@15,@8,@9,@10,@11,@12,@16,@17,@18
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_48x8_56_su	; @0-6 result (@6 MSB), @7-12 mult_s (@12 MSB)
						; @13 mult_u, @14 Hilfsreg
						; mult_s -140737488355328...140737488355327
						; mult_u 0...255
						; result -35888059530608640...35888059530608385
						; 17-206 cycles, 124 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=255 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @12,7
	rjmp mn1
	set
	neg48 @7,@8,@9,@10,@11,@12,@14
  mn1:

	multsoft_8x48_56 @0,@1,@2,@3,@4,@5,@6,@13,@7,@8,@9,@10,@11,@12,@14
	
	brtc end
	neg56 @0,@1,@2,@3,@4,@5,@6,@14
 end:
.endm




.macro multsoft_48x16_64_su	; @0-7 result (@7 MSB), @8-13 mult_s (@13 MSB)
						; @14.15 mult_u (@15 MSB), @16,17 Hilfsreg
						; mult_s -140737488355328...140737488355327
						; mult_u 0...65535
						; result -9223231299366420480...9223231299366354945
						; 21-436 cycles, 142 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=65535 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @13,7
	rjmp mn1
	set
	neg48 @8,@9,@10,@11,@12,@13,@16
  mn1:

	multsoft_16x48_64 @0,@1,@2,@3,@4,@5,@6,@7,@14,@15,@8,@9,@10,@11,@12,@13,@16,@17
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm




.macro multsoft_56x8_64_su	; @0-7 result (@7 MSB), @8-14 mult_s (@14 MSB)
						; @15 mult_u, @16 Hilfsreg
						; mult_s -36028797018963968...36028797018963967
						; mult_u 0...255
						; result -9187343239835811840...9187343239835811585
						; 18-227 cycles, 138 bytes
						; min.cycles wenn mult_u=0
						; max.cycles wenn mult_u=255 und mult_s<0
	clt			; mult_s Zeichen
	sbrs @14,7
	rjmp mn1
	set
	neg56 @8,@9,@10,@11,@12,@13,@14,@16
  mn1:

	multsoft_8x56_64 @0,@1,@2,@3,@4,@5,@6,@7,@15,@8,@9,@10,@11,@12,@13,@14,@16
	
	brtc end
	neg64 @0,@1,@2,@3,@4,@5,@6,@7,@16
 end:
.endm

;=================================================================================
;=================================================================================
;=================================================================================
 #endif /* _MULTSOFT_ */
